;==============================================================================
;
; MSX1 X^[tH[X
;
;	^Cg
;
;==============================================================================
val_cd_in_rom_2E5F		equ	#c3
val_6E86_in_rom_2E60	equ	put_title

public	put_title
put_title:
		ld		hl,#fc9e+1
		ld		a,r
		xor		(hl)
		and		3
		jp		z,put_title_fc
		dec		a
		jp		z,put_title_nes
		dec		a
		jp		z,put_title_arcade
put_title_msx:
		call	#6e86		; PCG64`127
		ld		hl,(#f3c7)	; name_tbl
		ld		bc,#0040
		add		hl,bc
		call	set_vram_adr_hl

		ld		hl,#6f06
		ld		b,#09		; c9L
	_lpH:
		push	bc
		ld		b,#20		; 20L
	_lpL:
		ld		a,(hl)
		or		a
		jr		z,_put
		sub		#80
	_put:
		out		(c),a
		inc		hl
		djnz	_lpL
		pop		bc
		djnz	_lpH
		ret

macro	mPutTitle, _pcgAdr, _pcgSize, _nameSize, _nameOfs
		ld		de,(#f3cb)
		call	_write_title_pcg
		ld		a,d
		add		a,#08
		ld		d,a
		call	_write_title_pcg

		ld		de,(#f3c7)
		ex		de,hl
		ld		bc,_nameOfs
		add		hl,bc
		ex		de,hl
		ld		bc,_nameSize
		jp		di_005c

	_write_title_pcg:
		push	de
		ld		hl,_pcgAdr
		ld		bc,_pcgSize
		push	de
		call	di_005c
		pop		de
		ld		a,d
		add		a,#20
		ld		d,a
		ld		bc,_pcgSize
		call	di_005c
		pop		de
		ret
endm
put_title_fc:
		mPutTitle	title_fc_pcg, #0280, 32*10, #0040
put_title_nes:
		mPutTitle	title_nes_pcg, #0400, 32*6, #0040

put_title_arcade:
		ld		hl,#4000
		ld		bc,#300
		xor		a
		call	di_0056
		ld		hl,#8000
		ld		bc,128*128
		xor		a
		call	di_0056

		ld		hl,title_arcade_lze
		ld		de,#8810
		ld		b,#40
	_lp_lze:
		push	bc

		push	de
		ld		de,#e000
		call	DECODE_LZE
		pop		de

		push	hl
		call	set_vram_adr_de
		ld		hl,#e000
		ld		b,#60
		otir
		ld		a,#80
		call	add_de_a
		pop		hl

		pop		bc
		djnz	_lp_lze

		ld		hl,title_arcade_palette
		ld		de,#e000
		ld		bc,#20
		ldir

	_init_hkeyi:
		ld		hl,hkeyi_title_arcade
		ld		de,#e020
		ld		bc,end_hkeyi_title_arcade-hkeyi_title_arcade
		ldir

		di
		;HTIMIZbg
		ld		a,#c3
		ld		(#fd9a),a
		ld		hl,#e020
		ld		(#fd9a+1),hl

		;VDPo̓|[g擾
		ld		a,(#0007)
		inc		a
		ld		c,a

		;HSYNCCԍZbg
		ld		hl,#9300+64+16
		out		(c),l
		out		(c),h

        ret

; org	#e020Ƃ
hkeyi_title_arcade:
		ld		hl,#0006
		ld		b,(hl)
		inc		b
		inc		l
		ld		c,(hl)
		inc		c

		;HSYNC`FbN
		ld		hl,#8f01
		out		(c),l
		out		(c),h
		ld		a,c
		ld		c,b
		in		d,(c)
		ld		c,a

		;Xe[^XWX^0ZNg
		xor		a
		out		(c),a
		out		(c),h

		;sprite off
		ld		hl,#880a
		out		(c),l
		out		(c),h

		;scroll
		ld		hl,#9700
		out		(c),l
		out		(c),h

		rrc		d
		jr		c,_hsync
	;A荞
	_vblank:
		;screen5
        ld		hl,#8000+#16
		ld		de,#8200+#3f	; name #8000h
		out		(c),l
		out		(c),h
		out		(c),e
		out		(c),d
		;palette
		ld		hl,#e000
		jp		change_color_palette
        
	;荞
	_hsync:
		;``
		push	bc
		ld		hl,#e020+_null_pallet-hkeyi_title_arcade
		call	change_color_palette
		pop		bc
		;screen2
        ld		hl,#8000+#12
		ld		de,#8200+#10	; name #4000h
		out		(c),l
		out		(c),h
		out		(c),e
		out		(c),d
		;palette
		ld		hl,#ee30
		jp		change_color_palette
	_null_pallet:
		ds		#20
end_hkeyi_title_arcade:

;================================================
;//	LZE DECODE ROUTINE
;//	Original Copyright (C)1995,2008 GORRY.
;//	Porting for Z80 by Kei Moroboshi 2017/SEP.
	.Z80

;	PUBLIC	DECODE_LZE
;================================================
;LZEf[^fR[hB
;in	HL	fR[hOf[^ւ̃|C^
;	DE	fR[hf[^ւ̃|C^
;================================================
DECODE_LZE:
	PUSH	DE
	EXX
	POP	DE
	EXX

	LD	B,1	;BitCount=1
DECODE_LZE_lp0:
DECODE_LZE_1:
	LD	A,(HL)	;*(DECODEPtr++) = *(LZEPtr++);
	INC	HL
	EXX
	LD	(DE),A	;DE'=DECODEPtr
	INC	DE
	EXX

DECODE_LZE_lp1:
	DJNZ	SKIP	;if ( (--BitCount) == 0 ) {
	LD	C,(HL)	;	BitData = (int)*(LZEPtr++);
	INC	HL
	LD	B,8	;	BitCount = 8;
SKIP:	SLA	C	;	BitData <<= 1;

	JR	C,DECODE_LZE_1	;jc	DECODE_LZE_1

DECODE_LZE_0:
	EXX
	LD	HL,-1	;Distance=-1;
	EXX
	DJNZ	SKIP0	;if ( (--BitCount) == 0 ) {
	LD	C,(HL)	;	BitData = (int)*(LZEPtr++);
	INC	HL
	LD	B,8	;	BitCount = 8;
SKIP0:	SLA	C	;	BitData <<= 1;

	JR	C,DECODE_LZE_01	;jc	DECODE_LZE_01
DECODE_LZE_00:
	DJNZ	SKIP00	;if ( (--BitCount) == 0 ) {
	LD	C,(HL)	;	BitData = (int)*(LZEPtr++);
	INC	HL
	LD	B,8	;	BitCount = 8;
SKIP00:	SLA	C	;	BitData <<= 1;
	EXX
	LD	BC,0	;CopyCount = 0;
	RL	C
	RL	B	;adc	CopyCount,CopyCount
	EXX
	DJNZ	SKIP01	;if ( (--BitCount) == 0 ) {
	LD	C,(HL)	;	BitData = (int)*(LZEPtr++);
	INC	HL
	LD	B,8	;	BitCount = 8;
SKIP01:	SLA	C	;	BitData <<= 1;
	LD	A,(HL)	;	Distance = -256+((int)*(LZEPtr++));
	INC	HL
	EXX
	LD	L,A
	RL	C	;adc	CopyCount,CopyCount
	RL	B
DECODE_LZE_00_1:
	INC	BC	;inc	CopyCount
DECODE_LZE_00_2:
	ADD	HL,DE	;HL':CopyPtr=HL:Distance + DE':DECODEPtr
	INC	BC	;inc	CopyCount
	LDIR		;copy
	EXX
	JP	DECODE_LZE_lp1	;[[[ or JR ]]]

DECODE_LZE_01:
	LD	A,(HL)
	INC	HL
	EX	AF,AF'
	LD	A,(HL)
	INC	HL
	EXX
	LD	L,A
	EX	AF,AF'
;	LD	H,A
	LD	C,L		;mov	CopyCount,Distance
;	LD	B,H
;	LD	A,H
	RRA			;shr	Distance,1
	RR	L
	RRA			;shr	Distance,1
	RR	L
	RRA			;shr	Distance,1
	RR	L
	OR	0E0H		;or	DistanceH,0e0h
	LD	H,A

	LD	B,0
	LD	A,C
	AND	7		;and	CopyCount,7
	LD	C,A
	JP	NZ,DECODE_LZE_00_1	;[[[ or JR ]]]
 	EXX
	LD	A,(HL)
	INC	HL
	EXX
	LD	C,A	;C'=CopyCountL
	OR	A
	JP	NZ,DECODE_LZE_00_2	;[[[ or JR ]]]

	EXX
DECODE_LZE_e:
	RET


;================================================
title_fc_pcg:
incbin	"StarForce-title-fc.dat"

title_nes_pcg:
incbin	"StarForce-title-nes.dat"

title_arcade_lze:
incbin	"StarForce-title-arcade_192x64.lze"
title_arcade_palette:
	db	#00, #00, #77, #07, #70, #00, #03, #00
	db	#04, #00, #06, #00, #05, #00, #07, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
